Skip site navigation (1)Skip section navigation (2)
Date:      Thu, 22 Mar 2018 11:56:06 +0000 (UTC)
From:      Peter Holm <pho@FreeBSD.org>
To:        src-committers@freebsd.org, svn-src-user@freebsd.org
Subject:   svn commit: r331351 - user/pho/stress2/misc
Message-ID:  <201803221156.w2MBu6Jd037460@repo.freebsd.org>

next in thread | raw e-mail | index | archive | help
Author: pho
Date: Thu Mar 22 11:56:06 2018
New Revision: 331351
URL: https://svnweb.freebsd.org/changeset/base/331351

Log:
  Added an OOM killing test scenario, which triggers a hang.
  
  Sponsored by:	Dell EMC Isilon

Added:
  user/pho/stress2/misc/oom2.sh   (contents, props changed)

Added: user/pho/stress2/misc/oom2.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ user/pho/stress2/misc/oom2.sh	Thu Mar 22 11:56:06 2018	(r331351)
@@ -0,0 +1,51 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2018 Dell EMC Isilon
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# Test OOM killing.
+
+# sort stuck in "pfault" seen.
+# https://people.freebsd.org/~pho/stress/log/oom2.txt
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+[ `sysctl -n vm.swap_total` -gt 0 ] && { swapoff -a; off=1; }
+
+[ `sysctl -n hw.physmem` -gt $((32 * 1024 * 1024 * 1024)) ] &&
+	echo "RAM should be capped to no more than 32GB"
+n=`sysctl -n hw.ncpu`
+n=`jot $n`
+start=`date +%s`
+while [ $((`date +%s` - $start)) -lt 300 ]; do
+	for i in $n; do
+		sort < /dev/zero > /dev/null 2>&1 &
+	done
+	wait
+done
+[ $off ] && swapon -a
+exit 0



Want to link to this message? Use this URL: <https://mail-archive.FreeBSD.org/cgi/mid.cgi?201803221156.w2MBu6Jd037460>